//---------------------------------------------------------------------------------------
// created as RSSDocument.m by znek on Sun 29-Oct-2000
// $Id: RSSDocument.m,v 1.2 2001/07/30 10:47:10 znek Exp $
//
//  Copyright (c) 2000 by Marcus Mueller <znek@mulle-kybernetik.com>.
//  All rights reserved.
//
//  Permission to use, copy, modify and distribute this software and its documentation
//  is hereby granted under the terms of the GNU General Public License, version 2
//  as published by the Free Software Foundation, provided that both the copyright notice
//  and this permission notice appear in all copies of the software, derivative works or
//  modified versions, and any portions thereof, and that both notices appear in supporting
//  documentation, and that credit is given to Marcus Mueller in all documents and publicity
//  pertaining to direct or indirect use of this code or its derivatives.
//
//  This is free software; you can redistribute and/or modify it under
//  the terms of the GNU General Public License, version 2 as published by the Free
//  Software Foundation. Further information can be found on the project's web pages
//  at http://www.mulle-kybernetik.com/software/MKPortal
//
//  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH MAY HAVE
//  SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS SOFTWARE IN ITS
//  "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY
//  DAMAGES WHATSOEVER RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE
//  OR OF ANY DERIVATIVE WORK.
//---------------------------------------------------------------------------------------


#import "RSSDocument.h"
#import <EDCommon/EDCommon.h>
#import "RSSChannel.h"


@implementation RSSDocument

////////////////////////////////////////////////////
//
//	INIT
//
////////////////////////////////////////////////////


- init
{
  [super init];
  _encoding = NSUTF8StringEncoding;
  return self;
}


////////////////////////////////////////////////////
//
//	OVERRIDING FUN
//
////////////////////////////////////////////////////


- (void)addContainedElement:(MXElement *)someElement
{
  if([someElement isKindOfClass:[RSSChannel class]])
  {
    [self takeValue:someElement forAttribute:@"channel"];
  }
}


////////////////////////////////////////////////////
//
//	ACCESSORS
//
////////////////////////////////////////////////////


- (RSSChannel *)channel
{
  return [self valueForAttribute:@"channel"];
}

- (void)setEncoding:(NSStringEncoding)encoding
{
  _encoding = encoding;
}

- (NSStringEncoding)encoding
{
  return _encoding;
}


////////////////////////////////////////////////////
//
//	EASE OF USE
//	ACCESSORS
//
////////////////////////////////////////////////////

// strictly speaking, these "wrappers" are incorrectly placed here.
// in the case of RDF documents, however, that's the place where they
// are. Our code benefits a lot by handling everything in a uniform way.

- (NSString *)title
{
	return [[self channel] title];
}

- (NSString *)link
{
	return [[self channel] link];
}

- (NSArray *)items
{
	return [[self channel] items];
}


////////////////////////////////////////////////////
//
//	DEBUGGING
//
////////////////////////////////////////////////////


- (NSString *)description
{
  return [NSString stringWithFormat:@"<%@ 0x%x: title=\"%@\" items=\"%@\">", NSStringFromClass([self class]), self, [self title], [self items]];
}

@end
